<!DOCTYPE html>
<html class="writer-html5" lang="en" >
<head>
  <meta charset="utf-8" /><meta name="generator" content="Docutils 0.17.1: http://docutils.sourceforge.net/" />

  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  <title>components &mdash; PYKKN 0.1 documentation</title>
      <link rel="stylesheet" href="../../_static/pygments.css" type="text/css" />
      <link rel="stylesheet" href="../../_static/css/theme.css" type="text/css" />
      <link rel="stylesheet" href="../../_static/graphviz.css" type="text/css" />
      <link rel="stylesheet" href="../../_static/panels-bootstrap.5fd3999ee7762ccc51105388f4a9d115.css" type="text/css" />
      <link rel="stylesheet" href="../../_static/panels-main.c949a650a448cc0ae9fd3441c0e17fb0.css" type="text/css" />
      <link rel="stylesheet" href="../../_static/panels-variables.06eb56fa6e07937060861dad626602ad.css" type="text/css" />
  <!--[if lt IE 9]>
    <script src="../../_static/js/html5shiv.min.js"></script>
  <![endif]-->
  
        <script data-url_root="../../" id="documentation_options" src="../../_static/documentation_options.js"></script>
        <script src="../../_static/jquery.js"></script>
        <script src="../../_static/underscore.js"></script>
        <script src="../../_static/doctools.js"></script>
    <script src="../../_static/js/theme.js"></script>
    <link rel="index" title="Index" href="../../genindex.html" />
    <link rel="search" title="Search" href="../../search.html" />
    <link rel="next" title="components.dataset" href="dataset/index.html" />
    <link rel="prev" title="API Reference" href="../index.html" /> 
</head>

<body class="wy-body-for-nav"> 
  <div class="wy-grid-for-nav">
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >
            <a href="../../index.html" class="icon icon-home"> PYKKN
          </a>
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>
        </div><div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="Navigation menu">
              <ul class="current">
<li class="toctree-l1"><a class="reference internal" href="../../start/index.html">Getting Started</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../user/index.html">User Guide</a></li>
<li class="toctree-l1 current"><a class="reference internal" href="../index.html">API reference</a><ul class="current">
<li class="toctree-l2 current"><a class="current reference internal" href="#"><code class="xref py py-mod docutils literal notranslate"><span class="pre">components</span></code></a><ul>
<li class="toctree-l3"><a class="reference internal" href="#submodules">Submodules</a><ul>
<li class="toctree-l4"><a class="reference internal" href="dataset/index.html"><code class="xref py py-mod docutils literal notranslate"><span class="pre">components.dataset</span></code></a></li>
<li class="toctree-l4"><a class="reference internal" href="dataset_image/index.html"><code class="xref py py-mod docutils literal notranslate"><span class="pre">components.dataset_image</span></code></a></li>
<li class="toctree-l4"><a class="reference internal" href="dataset_keyvalue/index.html"><code class="xref py py-mod docutils literal notranslate"><span class="pre">components.dataset_keyvalue</span></code></a></li>
<li class="toctree-l4"><a class="reference internal" href="dataset_video/index.html"><code class="xref py py-mod docutils literal notranslate"><span class="pre">components.dataset_video</span></code></a></li>
<li class="toctree-l4"><a class="reference internal" href="instrument/index.html"><code class="xref py py-mod docutils literal notranslate"><span class="pre">components.instrument</span></code></a></li>
<li class="toctree-l4"><a class="reference internal" href="model/index.html"><code class="xref py py-mod docutils literal notranslate"><span class="pre">components.model</span></code></a></li>
<li class="toctree-l4"><a class="reference internal" href="parameter/index.html"><code class="xref py py-mod docutils literal notranslate"><span class="pre">components.parameter</span></code></a></li>
<li class="toctree-l4"><a class="reference internal" href="pipeline/index.html"><code class="xref py py-mod docutils literal notranslate"><span class="pre">components.pipeline</span></code></a></li>
<li class="toctree-l4"><a class="reference internal" href="run/index.html"><code class="xref py py-mod docutils literal notranslate"><span class="pre">components.run</span></code></a></li>
<li class="toctree-l4"><a class="reference internal" href="storage/index.html"><code class="xref py py-mod docutils literal notranslate"><span class="pre">components.storage</span></code></a></li>
</ul>
</li>
<li class="toctree-l3"><a class="reference internal" href="#package-contents">Package Contents</a><ul>
<li class="toctree-l4"><a class="reference internal" href="#classes">Classes</a></li>
</ul>
</li>
</ul>
</li>
</ul>
</li>
</ul>

        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap"><nav class="wy-nav-top" aria-label="Mobile navigation menu" >
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../../index.html">PYKKN</a>
      </nav>

      <div class="wy-nav-content">
        <div class="rst-content">
          <div role="navigation" aria-label="Page navigation">
  <ul class="wy-breadcrumbs">
      <li><a href="../../index.html" class="icon icon-home"></a> &raquo;</li>
          <li><a href="../index.html">API Reference</a> &raquo;</li>
      <li><code class="xref py py-mod docutils literal notranslate"><span class="pre">components</span></code></li>
      <li class="wy-breadcrumbs-aside">
            <a href="../../_sources/reference/components/index.rst.txt" rel="nofollow"> View page source</a>
      </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
             
  <section id="module-components">
<span id="components"></span><h1><a class="reference internal" href="#module-components" title="components"><code class="xref py py-mod docutils literal notranslate"><span class="pre">components</span></code></a><a class="headerlink" href="#module-components" title="Permalink to this headline"></a></h1>
<section id="submodules">
<h2>Submodules<a class="headerlink" href="#submodules" title="Permalink to this headline"></a></h2>
<div class="toctree-wrapper compound">
<ul>
<li class="toctree-l1"><a class="reference internal" href="dataset/index.html"><code class="xref py py-mod docutils literal notranslate"><span class="pre">components.dataset</span></code></a></li>
<li class="toctree-l1"><a class="reference internal" href="dataset_image/index.html"><code class="xref py py-mod docutils literal notranslate"><span class="pre">components.dataset_image</span></code></a></li>
<li class="toctree-l1"><a class="reference internal" href="dataset_keyvalue/index.html"><code class="xref py py-mod docutils literal notranslate"><span class="pre">components.dataset_keyvalue</span></code></a></li>
<li class="toctree-l1"><a class="reference internal" href="dataset_video/index.html"><code class="xref py py-mod docutils literal notranslate"><span class="pre">components.dataset_video</span></code></a></li>
<li class="toctree-l1"><a class="reference internal" href="instrument/index.html"><code class="xref py py-mod docutils literal notranslate"><span class="pre">components.instrument</span></code></a></li>
<li class="toctree-l1"><a class="reference internal" href="model/index.html"><code class="xref py py-mod docutils literal notranslate"><span class="pre">components.model</span></code></a></li>
<li class="toctree-l1"><a class="reference internal" href="parameter/index.html"><code class="xref py py-mod docutils literal notranslate"><span class="pre">components.parameter</span></code></a></li>
<li class="toctree-l1"><a class="reference internal" href="pipeline/index.html"><code class="xref py py-mod docutils literal notranslate"><span class="pre">components.pipeline</span></code></a></li>
<li class="toctree-l1"><a class="reference internal" href="run/index.html"><code class="xref py py-mod docutils literal notranslate"><span class="pre">components.run</span></code></a></li>
<li class="toctree-l1"><a class="reference internal" href="storage/index.html"><code class="xref py py-mod docutils literal notranslate"><span class="pre">components.storage</span></code></a></li>
</ul>
</div>
</section>
<section id="package-contents">
<h2>Package Contents<a class="headerlink" href="#package-contents" title="Permalink to this headline"></a></h2>
<section id="classes">
<h3>Classes<a class="headerlink" href="#classes" title="Permalink to this headline"></a></h3>
<table class="autosummary longtable docutils align-default">
<colgroup>
<col style="width: 10%" />
<col style="width: 90%" />
</colgroup>
<tbody>
<tr class="row-odd"><td><p><a class="reference internal" href="#components.Storage" title="components.Storage"><code class="xref py py-obj docutils literal notranslate"><span class="pre">Storage</span></code></a></p></td>
<td><p>This class is an abstracted for all other classes, providing initialization function with a name</p></td>
</tr>
<tr class="row-even"><td><p><a class="reference internal" href="#components.Dataset_Image" title="components.Dataset_Image"><code class="xref py py-obj docutils literal notranslate"><span class="pre">Dataset_Image</span></code></a></p></td>
<td><p>An object of this class represents 1 image (Multiple images have not been considered or investigated yet).</p></td>
</tr>
<tr class="row-odd"><td><p><a class="reference internal" href="#components.Dataset_Video" title="components.Dataset_Video"><code class="xref py py-obj docutils literal notranslate"><span class="pre">Dataset_Video</span></code></a></p></td>
<td><p>An object of this class represents the video dataset.</p></td>
</tr>
<tr class="row-even"><td><p><a class="reference internal" href="#components.Parameter" title="components.Parameter"><code class="xref py py-obj docutils literal notranslate"><span class="pre">Parameter</span></code></a></p></td>
<td><p>An object of this class represents the Parameter.</p></td>
</tr>
<tr class="row-odd"><td><p><a class="reference internal" href="#components.Model" title="components.Model"><code class="xref py py-obj docutils literal notranslate"><span class="pre">Model</span></code></a></p></td>
<td><p>This object is used to represent the model for data processing in the experiment</p></td>
</tr>
<tr class="row-even"><td><p><a class="reference internal" href="#components.Instrument" title="components.Instrument"><code class="xref py py-obj docutils literal notranslate"><span class="pre">Instrument</span></code></a></p></td>
<td><p>This class represents Datasets that are mapped from other datasets using a given model</p></td>
</tr>
<tr class="row-odd"><td><p><a class="reference internal" href="#components.Pipeline" title="components.Pipeline"><code class="xref py py-obj docutils literal notranslate"><span class="pre">Pipeline</span></code></a></p></td>
<td><p>This object represents a pipeline</p></td>
</tr>
<tr class="row-even"><td><p><a class="reference internal" href="#components.Run" title="components.Run"><code class="xref py py-obj docutils literal notranslate"><span class="pre">Run</span></code></a></p></td>
<td><p>This object represents the run structure</p></td>
</tr>
</tbody>
</table>
<dl class="py class">
<dt class="sig sig-object py" id="components.Storage">
<em class="property"><span class="pre">class</span><span class="w"> </span></em><span class="sig-prename descclassname"><span class="pre">components.</span></span><span class="sig-name descname"><span class="pre">Storage</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">name</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#components.Storage" title="Permalink to this definition"></a></dt>
<dd><p>This class is an abstracted for all other classes, providing initialization function with a name
and store function to generate an HDF5 file</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><p><strong>name</strong> (<em>str</em>) – the name of the instant</p>
</dd>
</dl>
<dl class="py method">
<dt class="sig sig-object py" id="components.Storage.set_storage_path">
<span class="sig-name descname"><span class="pre">set_storage_path</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">self</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">path</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#components.Storage.set_storage_path" title="Permalink to this definition"></a></dt>
<dd><p>set the storage path where you want to store the HDF5 file</p>
<div class="admonition attention">
<p class="admonition-title">Attention</p>
<p>please always use “/” in path string instead of “”</p>
</div>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><p><strong>path</strong> (<em>str</em>) – _description_</p>
</dd>
</dl>
</dd></dl>

<dl class="py method">
<dt class="sig sig-object py" id="components.Storage.is_overwritable">
<span class="sig-name descname"><span class="pre">is_overwritable</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">self</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#components.Storage.is_overwritable" title="Permalink to this definition"></a></dt>
<dd></dd></dl>

<dl class="py method">
<dt class="sig sig-object py" id="components.Storage.store_HDF5">
<span class="sig-name descname"><span class="pre">store_HDF5</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">self</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">root</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">None</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#components.Storage.store_HDF5" title="Permalink to this definition"></a></dt>
<dd></dd></dl>

<dl class="py method">
<dt class="sig sig-object py" id="components.Storage.store_json">
<span class="sig-name descname"><span class="pre">store_json</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">self</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">root</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">None</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#components.Storage.store_json" title="Permalink to this definition"></a></dt>
<dd></dd></dl>

<dl class="py method">
<dt class="sig sig-object py" id="components.Storage.store">
<span class="sig-name descname"><span class="pre">store</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">self</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">format</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">root</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">None</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#components.Storage.store" title="Permalink to this definition"></a></dt>
<dd></dd></dl>

<dl class="py method">
<dt class="sig sig-object py" id="components.Storage.__str__">
<span class="sig-name descname"><span class="pre">__str__</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">self</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#components.Storage.__str__" title="Permalink to this definition"></a></dt>
<dd><p>rewrite the built-in method to modify the behaviors of print() for this instance
to make the print result more readable</p>
<p>before:</p>
<p>&gt;&gt;&gt;print(run1)</p>
<p>&lt;run.Run object at 0x0000022AA45715A0&gt;</p>
<p>after:</p>
<p>&gt;&gt;&gt;print(run1)</p>
<p>‘run1’</p>
<p>here, the string ‘run1’ is the name of this instance</p>
</dd></dl>

<dl class="py method">
<dt class="sig sig-object py" id="components.Storage.__repr__">
<span class="sig-name descname"><span class="pre">__repr__</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">self</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#components.Storage.__repr__" title="Permalink to this definition"></a></dt>
<dd><p>rewrite the built-in method to modify the behaviors of print() for a list of instances
to make the print result more readable</p>
<p>before:</p>
<p>&gt;&gt;&gt;print(run1.pipelines)</p>
<p>[&lt;pipeline.Pipeline object at 0x0000022AA45715A0&gt;, &lt;pipeline.Pipeline object at 0x0000022AA4gd1s0&gt;]</p>
<p>after:</p>
<p>&gt;&gt;&gt;print(run1.pipelines)</p>
<p>[‘pipe1’, ‘pipe2’]</p>
<p>here, the strings ‘pipe1’ and ‘pipe2’ are the names of this instance</p>
</dd></dl>

<dl class="py method">
<dt class="sig sig-object py" id="components.Storage.show">
<span class="sig-name descname"><span class="pre">show</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">self</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#components.Storage.show" title="Permalink to this definition"></a></dt>
<dd><p>use the method to show the detailed information about this instance, for example all attributes and names.
It should return a string like this:</p>
<p class="rubric">Examples</p>
<p>&gt;&gt; msmtrun.show()</p>
<p>#### pipelines ####</p>
<p>[‘aa’, ‘bb’, ‘cc’]</p>
<p>#### parameters ####</p>
<p>[‘dd’, ‘ee’, ‘ff’]</p>
<p>#### attributes ####</p>
<p>‘author’ : ‘who’</p>
<p>‘author’ : ‘derGeraet’</p>
<p>‘pmanager’ : ‘tcorneli’</p>
<p>‘targettmp’ : 70</p>
<p>‘targetrps’ : 2</p>
<p>‘oil’ : ‘PA06’</p>
</dd></dl>

<dl class="py method">
<dt class="sig sig-object py" id="components.Storage.add_attrs_dict">
<span class="sig-name descname"><span class="pre">add_attrs_dict</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">self</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">dict</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#components.Storage.add_attrs_dict" title="Permalink to this definition"></a></dt>
<dd><p>Add a flat Dictionary of key values as a set of attributes.</p>
<dl class="simple">
<dt>dict<span class="classifier">str</span></dt><dd><p>The Dictionary consists of Key Value pairs, with the keys being the names of the attribute
and the value being the value assigned to the attribute</p>
</dd>
</dl>
</dd></dl>

<dl class="py method">
<dt class="sig sig-object py" id="components.Storage.encode">
<span class="sig-name descname"><span class="pre">encode</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">self</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">object</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#components.Storage.encode" title="Permalink to this definition"></a></dt>
<dd><p>encode anything as a string
Parameters:
———-
object: Any</p>
<blockquote>
<div><p>an object which can be an instance of any class</p>
</div></blockquote>
<dl class="simple">
<dt>object_string: str</dt><dd><p>an encoded string, maybe very long if the original object is large</p>
</dd>
</dl>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><p><strong>object</strong> (<em>Any</em>) – </p>
</dd>
<dt class="field-even">Return type</dt>
<dd class="field-even"><p>str</p>
</dd>
</dl>
</dd></dl>

<dl class="py method">
<dt class="sig sig-object py" id="components.Storage.decode">
<span class="sig-name descname"><span class="pre">decode</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">self</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">object_string</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#components.Storage.decode" title="Permalink to this definition"></a></dt>
<dd><p>decode a string as its original form
Parameters:
———–
object_string: str</p>
<blockquote>
<div><p>an encoded string</p>
</div></blockquote>
<dl class="simple">
<dt>object: object</dt><dd><p>this is a instance of its original class, you can check its type with type()</p>
</dd>
</dl>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><p><strong>object_string</strong> (<em>str</em>) – </p>
</dd>
<dt class="field-even">Return type</dt>
<dd class="field-even"><p>Storage.decode.object</p>
</dd>
</dl>
</dd></dl>

</dd></dl>

<dl class="py class">
<dt class="sig sig-object py" id="components.Dataset_Image">
<em class="property"><span class="pre">class</span><span class="w"> </span></em><span class="sig-prename descclassname"><span class="pre">components.</span></span><span class="sig-name descname"><span class="pre">Dataset_Image</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">name</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#components.Dataset_Image" title="Permalink to this definition"></a></dt>
<dd><p>Bases: <a class="reference internal" href="#components.Storage" title="components.Storage"><code class="xref py py-obj docutils literal notranslate"><span class="pre">Storage</span></code></a></p>
<p>An object of this class represents 1 image (Multiple images have not been considered or investigated yet).</p>
<p>The user only needs to provide the path of the image, this class will read it using the pillow lib</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><p><strong>name</strong> (<em>str</em>) – the name of the dataset</p>
</dd>
</dl>
<p class="rubric">Examples</p>
<p>ataset1 = Dataset_Image(‘image_dataset_1’)</p>
<p>dataset1.data = “/test/test_rig_1.jpg”</p>
<dl class="py method">
<dt class="sig sig-object py" id="components.Dataset_Image.data">
<em class="property"><span class="pre">property</span><span class="w"> </span></em><span class="sig-name descname"><span class="pre">data</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">self</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#components.Dataset_Image.data" title="Permalink to this definition"></a></dt>
<dd></dd></dl>

<dl class="py method">
<dt class="sig sig-object py" id="components.Dataset_Image.output_file">
<span class="sig-name descname"><span class="pre">output_file</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">self</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#components.Dataset_Image.output_file" title="Permalink to this definition"></a></dt>
<dd><p>this function is designed to export image</p>
</dd></dl>

</dd></dl>

<dl class="py class">
<dt class="sig sig-object py" id="components.Dataset_Video">
<em class="property"><span class="pre">class</span><span class="w"> </span></em><span class="sig-prename descclassname"><span class="pre">components.</span></span><span class="sig-name descname"><span class="pre">Dataset_Video</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">name</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#components.Dataset_Video" title="Permalink to this definition"></a></dt>
<dd><p>Bases: <a class="reference internal" href="#components.Storage" title="components.Storage"><code class="xref py py-obj docutils literal notranslate"><span class="pre">Storage</span></code></a></p>
<p>An object of this class represents the video dataset.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><p><strong>name</strong> (<em>str</em>) – the name of the dataset</p>
</dd>
</dl>
<p class="rubric">Examples</p>
<p>dataset1 = Dataset_Video(‘video_dataset_1’)</p>
<p>ataset1.data = r”C:/UsersAdministrator/Videos/Captures/test_meeting _recording.mp4”</p>
<p>dataset1.data = “C:/Users/Administrator/Videos/Captures/test_meeting _recording.mp4”</p>
<p>dataset1.attrs[‘timestamp’] = ‘2022-06-13 11:22:11’</p>
<p>dataset1.set_storage_path(‘test/test_ut_video.h5’)</p>
<p>dataset1.store()</p>
<dl class="py method">
<dt class="sig sig-object py" id="components.Dataset_Video.data">
<em class="property"><span class="pre">property</span><span class="w"> </span></em><span class="sig-name descname"><span class="pre">data</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">self</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#components.Dataset_Video.data" title="Permalink to this definition"></a></dt>
<dd></dd></dl>

<dl class="py method">
<dt class="sig sig-object py" id="components.Dataset_Video.output_file">
<span class="sig-name descname"><span class="pre">output_file</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">self</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">path_output</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#components.Dataset_Video.output_file" title="Permalink to this definition"></a></dt>
<dd><p>this function is designed to convert the binary format data into the original format</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><p><strong>path_output</strong> (<em>str</em>) – the path of output</p>
</dd>
</dl>
</dd></dl>

<dl class="py method">
<dt class="sig sig-object py" id="components.Dataset_Video.convert_pics">
<span class="sig-name descname"><span class="pre">convert_pics</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">self</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">path_output</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#components.Dataset_Video.convert_pics" title="Permalink to this definition"></a></dt>
<dd><p>this function is to convert the video file into frame segmentations</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><p><strong>path_output</strong> (<em>str</em>) – the path of output</p>
</dd>
</dl>
</dd></dl>

</dd></dl>

<dl class="py class">
<dt class="sig sig-object py" id="components.Parameter">
<em class="property"><span class="pre">class</span><span class="w"> </span></em><span class="sig-prename descclassname"><span class="pre">components.</span></span><span class="sig-name descname"><span class="pre">Parameter</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">name</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#components.Parameter" title="Permalink to this definition"></a></dt>
<dd><p>Bases: <a class="reference internal" href="#components.Storage" title="components.Storage"><code class="xref py py-obj docutils literal notranslate"><span class="pre">Storage</span></code></a></p>
<p>An object of this class represents the Parameter.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><p><strong>name</strong> (<em>str</em>) – the name of the parameter</p>
</dd>
</dl>
<p class="rubric">Examples</p>
<p>para1 = Parameter(‘para1’)</p>
<p>para1.attrs[‘value’] = 1
para1.attrs[‘units’] = ‘cm’</p>
<p>para1.attrs[‘variable’] = ‘-’</p>
<p>para1.attrs[‘origin’] = ‘this’</p>
</dd></dl>

<dl class="py class">
<dt class="sig sig-object py" id="components.Model">
<em class="property"><span class="pre">class</span><span class="w"> </span></em><span class="sig-prename descclassname"><span class="pre">components.</span></span><span class="sig-name descname"><span class="pre">Model</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">name</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#components.Model" title="Permalink to this definition"></a></dt>
<dd><p>Bases: <a class="reference internal" href="#components.Storage" title="components.Storage"><code class="xref py py-obj docutils literal notranslate"><span class="pre">Storage</span></code></a></p>
<p>This object is used to represent the model for data processing in the experiment</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><p><strong>name</strong> (<em>str</em>) – the name of the model</p>
</dd>
</dl>
<p class="rubric">Examples</p>
<p>model = Model(‘model1’)</p>
<p>model.add([parameter1, parameter2])</p>
<dl class="py method">
<dt class="sig sig-object py" id="components.Model.add">
<span class="sig-name descname"><span class="pre">add</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">self</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">list_obj</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#components.Model.add" title="Permalink to this definition"></a></dt>
<dd><p>add (multi) parameter(s) into model</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><p><strong>list_obj</strong> (<em>List</em><em>[</em><a class="reference internal" href="#components.Parameter" title="components.Parameter"><em>Parameter</em></a><em>]</em>) – a list of Parameter object(s)</p>
</dd>
<dt class="field-even">Raises</dt>
<dd class="field-even"><p><strong>AssertionError:</strong> – raise when add method fails</p>
</dd>
</dl>
</dd></dl>

</dd></dl>

<dl class="py class">
<dt class="sig sig-object py" id="components.Instrument">
<em class="property"><span class="pre">class</span><span class="w"> </span></em><span class="sig-prename descclassname"><span class="pre">components.</span></span><span class="sig-name descname"><span class="pre">Instrument</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">name</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#components.Instrument" title="Permalink to this definition"></a></dt>
<dd><p>Bases: <a class="reference internal" href="#components.Storage" title="components.Storage"><code class="xref py py-obj docutils literal notranslate"><span class="pre">Storage</span></code></a></p>
<p>This class represents Datasets that are mapped from other datasets using a given model</p>
<p>This can be used to convert the input of a sensor to its actual physical data using the given model,
for example polynomials or lookup tables.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><p><strong>name</strong> (<em>str</em>) – the name of the instrument</p>
</dd>
</dl>
<p class="rubric">Examples</p>
<p>instrument = Instrument(‘instrument1’)</p>
<p>instrument.add([model1, model2])</p>
<dl class="py method">
<dt class="sig sig-object py" id="components.Instrument.add">
<span class="sig-name descname"><span class="pre">add</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">self</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">list_obj</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#components.Instrument.add" title="Permalink to this definition"></a></dt>
<dd><p>add (multi) model(s) into instrument</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><p><strong>list_obj</strong> (<em>List</em><em>[</em><a class="reference internal" href="#components.Model" title="components.Model"><em>Model</em></a><em>]</em>) – a list of Model object(s)</p>
</dd>
<dt class="field-even">Raises</dt>
<dd class="field-even"><p><strong>AssertionError:</strong> – raise when adding method fails</p>
</dd>
</dl>
</dd></dl>

</dd></dl>

<dl class="py class">
<dt class="sig sig-object py" id="components.Pipeline">
<em class="property"><span class="pre">class</span><span class="w"> </span></em><span class="sig-prename descclassname"><span class="pre">components.</span></span><span class="sig-name descname"><span class="pre">Pipeline</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">name</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#components.Pipeline" title="Permalink to this definition"></a></dt>
<dd><p>Bases: <a class="reference internal" href="#components.Storage" title="components.Storage"><code class="xref py py-obj docutils literal notranslate"><span class="pre">Storage</span></code></a></p>
<p>This object represents a pipeline</p>
<p>This name of pipeline should contain the following information:</p>
<p>&lt;measured/derived&gt;/&lt;capa&gt;/&lt;raw/scaled&gt;</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><p><strong>name</strong> (<em>str</em>) – the name of the pipeline</p>
</dd>
</dl>
<p class="rubric">Examples</p>
<p>pipeline1 = Pipeline(‘measured/capa1/raw’)</p>
<p>pipeline1.attrs[‘variable’] = ‘voltage’</p>
<p>pipeline1.attrs[‘units’] = ‘volts’</p>
<p>pipeline1.attrs[‘origin’] = ‘this’</p>
<p>pipeline.add([dataset1, dataset2])</p>
<p>pipeline.add([instrument1, insturment2])</p>
<dl class="py method">
<dt class="sig sig-object py" id="components.Pipeline.add">
<span class="sig-name descname"><span class="pre">add</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">self</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">list_obj</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#components.Pipeline.add" title="Permalink to this definition"></a></dt>
<dd><p>add (multi) dataset(s) and instrument(s) into model</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><p><strong>list_obj</strong> (<em>List</em><em>[</em><a class="reference internal" href="#components.Instrument" title="components.Instrument"><em>Instrument</em></a><em>  |  </em><a class="reference internal" href="dataset/index.html#components.dataset.Dataset" title="components.dataset.Dataset"><em>Dataset</em></a><em>]</em>) – a list of Instrument or Dataset object(s)</p>
</dd>
<dt class="field-even">Raises</dt>
<dd class="field-even"><ul class="simple">
<li><p><strong>TypeError</strong> – raised when the element of list_obj is not the type of Instrument or Dataset</p></li>
<li><p><strong>AssertionError</strong> – raised when list_obj is not a list or it is empty</p></li>
</ul>
</dd>
</dl>
</dd></dl>

</dd></dl>

<dl class="py class">
<dt class="sig sig-object py" id="components.Run">
<em class="property"><span class="pre">class</span><span class="w"> </span></em><span class="sig-prename descclassname"><span class="pre">components.</span></span><span class="sig-name descname"><span class="pre">Run</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">name</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#components.Run" title="Permalink to this definition"></a></dt>
<dd><p>Bases: <a class="reference internal" href="#components.Storage" title="components.Storage"><code class="xref py py-obj docutils literal notranslate"><span class="pre">Storage</span></code></a></p>
<p>This object represents the run structure</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><p><strong>name</strong> (<em>str</em>) – the name of the run</p>
</dd>
</dl>
<p class="rubric">Examples</p>
<p>run1 = Run(‘run1’)</p>
<p>run1.add([parameter1, parameter2])</p>
<p>run1.add([pipeline1, pipeline2])</p>
<dl class="py method">
<dt class="sig sig-object py" id="components.Run.add">
<span class="sig-name descname"><span class="pre">add</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">self</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">list_obj</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#components.Run.add" title="Permalink to this definition"></a></dt>
<dd><p>add (multi) parameter(s) or pipeline(s) into run</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><p><strong>list_obj</strong> (<em>List</em><em>[</em><a class="reference internal" href="#components.Parameter" title="components.Parameter"><em>Parameter</em></a><em> | </em><a class="reference internal" href="#components.Pipeline" title="components.Pipeline"><em>Pipeline</em></a><em>]</em>) – a list of Parameter or Pipeline object(s)</p>
</dd>
<dt class="field-even">Raises</dt>
<dd class="field-even"><p><strong>AssertionError:</strong> – raise when add method fails</p>
</dd>
</dl>
</dd></dl>

</dd></dl>

</section>
</section>
</section>


           </div>
          </div>
          <footer><div class="rst-footer-buttons" role="navigation" aria-label="Footer">
        <a href="../index.html" class="btn btn-neutral float-left" title="API Reference" accesskey="p" rel="prev"><span class="fa fa-arrow-circle-left" aria-hidden="true"></span> Previous</a>
        <a href="dataset/index.html" class="btn btn-neutral float-right" title="components.dataset" accesskey="n" rel="next">Next <span class="fa fa-arrow-circle-right" aria-hidden="true"></span></a>
    </div>

  <hr/>

  <div role="contentinfo">
    <p>&#169; Copyright 2022, ADP Group.</p>
  </div>

  Built with <a href="https://www.sphinx-doc.org/">Sphinx</a> using a
    <a href="https://github.com/readthedocs/sphinx_rtd_theme">theme</a>
    provided by <a href="https://readthedocs.org">Read the Docs</a>.
   

</footer>
        </div>
      </div>
    </section>
  </div>
  <script>
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script> 

</body>
</html>